import simplegui
image = simplegui.load_image("http://commondatastorage.googleapis.com/codeskulptor-assets/gutenberg.jpg")
MAP_WIDTH = 1521
MAP_HEIGHT  = 1818
#scaling factor
SCALE = 3

#canvas size
CAN_WIDTH = MAP_WIDTH//SCALE
CAN_HEIGHT = MAP_HEIGHT//SCALE

#size of magnifier pane and initial center
MAG_SIZE = 120
mag_pos = [CAN_WIDTH//2,CAN_HEIGHT//2]

#event Handlers
#move magnifier to clicked position
def click(pos):
    global mag_pos
    mag_pos = list(pos)

#Draw map and magnified region
def draw(canvas):
    #draw map
    canvas.draw_image(image,
                      [MAP_WIDTH//2,MAP_HEIGHT//2],[MAP_WIDTH,MAP_HEIGHT],
                      [CAN_WIDTH//2,CAN_HEIGHT//2],[CAN_WIDTH,CAN_HEIGHT])
    #DRAW magnifier
    map_center = [SCALE * mag_pos[0],SCALE * mag_pos[1]]
    map_rectangle = [MAG_SIZE,MAG_SIZE]
    mag_center = mag_pos
    mag_rectangle = [MAG_SIZE,MAG_SIZE]
    canvas.draw_image(image,map_center,map_rectangle,mag_center,mag_rectangle)

#create frame
frame = simplegui.create_frame("Map Magnifier",CAN_WIDTH,CAN_HEIGHT)

#register event handlers
frame.set_mouseclick_handler(click)
frame.set_draw_handler(draw)
frame.start()